﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using Eclipse.Healbot.Routine;
using TreeSharp;
using Action = TreeSharp.Action;
using Eclipse.HealBot;
using ff14bot.Behavior;
using ff14bot.Objects;

namespace Eclipse.Healbot.Routine.Rotations
{
    class ConjurerWhiteMage : EclipseRoutine
    {

        //DEVELOPERS REPLACE GetType().Name WITH YOUR CR'S NAME.
        public override string Name { get { return "Eclipse-Healbot [HealBot]"; } }

        public override ClassJobType[] Class
        {
            get { return new[] { ClassJobType.Conjurer, ClassJobType.WhiteMage, }; }
        }
        public override int PullRange
        {
            get { return 20; }
        }


        protected override Composite CreatePreCombatBuffs()
        {
            return new PrioritySelector(
                new Sequence(new Action(ret => EC.log("CreatePreCombatBuffs")), new ActionAlwaysFail()),
                new Decorator(ret=> !GameObjectManager.LocalPlayer.HasAura("Protect"), Apply("Protect", r => true, r => Core.Player)),
                new Decorator(ret => EC.Tank != null && !EC.Tank.HasAura("Stoneskin"), Apply("StoneSkin"))
            );
        }
        protected override Composite CreateHeal()
        {
            return new PrioritySelector(
                new Sequence(new Action(ret => EC.log("In teh heal method - Im at:" + Core.Player.CurrentHealthPercent)), new ActionAlwaysFail()),
                new Decorator(ret=>Core.Player.HasAura("Cleric Stance"), Apply("Cleric Stance")),
                new Decorator(ret => Core.Player.HasAura("Cleric Stance"), Apply("Cleric Stance")),
                new Decorator(ret=> Core.Player.CurrentTarget != null,
                    new PrioritySelector(
                        new Sequence(new Action(ret => EC.log("EC.Needy != null:" + Core.Player.CurrentHealthPercent)), new ActionAlwaysFail()),
                        Cast("Cure II", r=> Core.Player.HasAura("Freecure") && EC.needy.CurrentHealthPercent < 95),
                        Cast("Cure", ret => EC.needy.CurrentHealthPercent <= 80 && EC.needy.CurrentHealthPercent != 0),
                        Apply("Stoneskin", ret => !EC.needy.Obj.HasAura("Stoneskin") && EC.needy.CurrentHealthPercent > 85 && Core.Player.CurrentManaPercent > 20),
                        Apply("Protect", ret=>!EC.needy.Obj.HasAura("Protect") && EC.needy.CurrentHealthPercent > 85 && Core.Player.CurrentManaPercent > 20)
                    ))
            );

        }
    }
}